# Web Component

## Installation

To install the package, use the following command:

```bash
npm i @engineai-dev/web-component
```

Alternatively, you can import the `UMD/ESM` bundle directly as a script tag.

## Usage

To use the package, add the following code to your HTML file:

```html
<engineai-web-component
    src="https://example.engineai.com"
></engineai-web-component>
```

## Attributes

The following attributes are available:

### `src`

This attribute specifies the URL of the EngineAI platform to load.

### `token`

This attribute specifies a valid authentication token to use when loading the EngineAI platform. If not provided, the platform will attempt to authenticate the user using a stored token or prompt the user to log in.

### `options`

This attribute specifies a json configuration to use when loading the EngineAI platform.

### `indexable`

This attribute can be set to `"true"`. This way, the internal navigation of the EngineAI platform will be persisted in a query parameter called `embed_url`. This makes the current URL shareable for others.

### `resizable`

This attribute can be set to `"false"`. This way, we can force the embed app to be responsive to the container, otherwise the embed app will resize based on the dashboard size.

## Events

The following events are available:

### `state-change`

This event is triggered when the EngineAI platform changes state. The event's detail property contains the platform's event type and the associated data.

# Examples

## Angular Integration

To see the attributes and events in action, please refer to the Angular web app demo available in the [Angular Demo](../../examples/angular-demo).
