/**
 * @license
 * Copyright 2019 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
const B = globalThis, he = B.ShadowRoot && (B.ShadyCSS === void 0 || B.ShadyCSS.nativeShadow) && "adoptedStyleSheets" in Document.prototype && "replace" in CSSStyleSheet.prototype, pe = Symbol(), ge = /* @__PURE__ */ new WeakMap();
class Ie {
  constructor(e, t, n) {
    if (this._$cssResult$ = !0, n !== pe)
      throw new Error("CSSResult is not constructable. Use `unsafeCSS` or `css` instead.");
    this.cssText = e, this._strings = t;
  }
  // This is a getter so that it's lazy. In practice, this means stylesheets
  // are not created until the first element instance is made.
  get styleSheet() {
    let e = this._styleSheet;
    const t = this._strings;
    if (he && e === void 0) {
      const n = t !== void 0 && t.length === 1;
      n && (e = ge.get(t)), e === void 0 && ((this._styleSheet = e = new CSSStyleSheet()).replaceSync(this.cssText), n && ge.set(t, e));
    }
    return e;
  }
  toString() {
    return this.cssText;
  }
}
const Je = (i) => {
  if (i._$cssResult$ === !0)
    return i.cssText;
  if (typeof i == "number")
    return i;
  throw new Error(`Value passed to 'css' function must be a 'css' function result: ${i}. Use 'unsafeCSS' to pass non-literal values, but take care to ensure page security.`);
}, Ye = (i) => new Ie(typeof i == "string" ? i : String(i), void 0, pe), Ge = (i, ...e) => {
  const t = i.length === 1 ? i[0] : e.reduce((n, s, r) => n + Je(s) + i[r + 1], i[0]);
  return new Ie(t, i, pe);
}, Qe = (i, e) => {
  if (he)
    i.adoptedStyleSheets = e.map((t) => t instanceof CSSStyleSheet ? t : t.styleSheet);
  else
    for (const t of e) {
      const n = document.createElement("style"), s = B.litNonce;
      s !== void 0 && n.setAttribute("nonce", s), n.textContent = t.cssText, i.appendChild(n);
    }
}, Ze = (i) => {
  let e = "";
  for (const t of i.cssRules)
    e += t.cssText;
  return Ye(e);
}, ye = he ? (i) => i : (i) => i instanceof CSSStyleSheet ? Ze(i) : i;
/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
const { is: je, defineProperty: Ke, getOwnPropertyDescriptor: be, getOwnPropertyNames: Xe, getOwnPropertySymbols: et, getPrototypeOf: $e } = Object, g = globalThis;
let $;
const we = g.trustedTypes, tt = we ? we.emptyScript : "", q = g.reactiveElementPolyfillSupportDevMode;
var Ae;
{
  const i = g.litIssuedWarnings ?? (g.litIssuedWarnings = /* @__PURE__ */ new Set());
  $ = (e, t) => {
    t += ` See https://lit.dev/msg/${e} for more information.`, i.has(t) || (console.warn(t), i.add(t));
  }, $("dev-mode", "Lit is in dev mode. Not recommended for production!"), (Ae = g.ShadyDOM) != null && Ae.inUse && q === void 0 && $("polyfill-support-missing", "Shadow DOM is being polyfilled via `ShadyDOM` but the `polyfill-support` module has not been loaded.");
}
const X = (i) => {
  g.emitLitDebugLogEvents && g.dispatchEvent(new CustomEvent("lit-debug", {
    detail: i
  }));
}, N = (i, e) => i, Y = {
  toAttribute(i, e) {
    switch (e) {
      case Boolean:
        i = i ? tt : null;
        break;
      case Object:
      case Array:
        i = i == null ? i : JSON.stringify(i);
        break;
    }
    return i;
  },
  fromAttribute(i, e) {
    let t = i;
    switch (e) {
      case Boolean:
        t = i !== null;
        break;
      case Number:
        t = i === null ? null : Number(i);
        break;
      case Object:
      case Array:
        try {
          t = JSON.parse(i);
        } catch {
          t = null;
        }
        break;
    }
    return t;
  }
}, ue = (i, e) => !je(i, e), Se = {
  attribute: !0,
  type: String,
  converter: Y,
  reflect: !1,
  hasChanged: ue
};
Symbol.metadata ?? (Symbol.metadata = Symbol("metadata"));
g.litPropertyMetadata ?? (g.litPropertyMetadata = /* @__PURE__ */ new WeakMap());
class P extends HTMLElement {
  /**
   * Adds an initializer function to the class that is called during instance
   * construction.
   *
   * This is useful for code that runs against a `ReactiveElement`
   * subclass, such as a decorator, that needs to do work for each
   * instance, such as setting up a `ReactiveController`.
   *
   * ```ts
   * const myDecorator = (target: typeof ReactiveElement, key: string) => {
   *   target.addInitializer((instance: ReactiveElement) => {
   *     // This is run during construction of the element
   *     new MyController(instance);
   *   });
   * }
   * ```
   *
   * Decorating a field will then cause each instance to run an initializer
   * that adds a controller:
   *
   * ```ts
   * class MyElement extends LitElement {
   *   @myDecorator foo;
   * }
   * ```
   *
   * Initializers are stored per-constructor. Adding an initializer to a
   * subclass does not add it to a superclass. Since initializers are run in
   * constructors, initializers will run in order of the class hierarchy,
   * starting with superclasses and progressing to the instance's class.
   *
   * @nocollapse
   */
  static addInitializer(e) {
    this.__prepare(), (this._initializers ?? (this._initializers = [])).push(e);
  }
  /**
   * Returns a list of attributes corresponding to the registered properties.
   * @nocollapse
   * @category attributes
   */
  static get observedAttributes() {
    return this.finalize(), this.__attributeToPropertyMap && [...this.__attributeToPropertyMap.keys()];
  }
  /**
   * Creates a property accessor on the element prototype if one does not exist
   * and stores a {@linkcode PropertyDeclaration} for the property with the
   * given options. The property setter calls the property's `hasChanged`
   * property option or uses a strict identity check to determine whether or not
   * to request an update.
   *
   * This method may be overridden to customize properties; however,
   * when doing so, it's important to call `super.createProperty` to ensure
   * the property is setup correctly. This method calls
   * `getPropertyDescriptor` internally to get a descriptor to install.
   * To customize what properties do when they are get or set, override
   * `getPropertyDescriptor`. To customize the options for a property,
   * implement `createProperty` like this:
   *
   * ```ts
   * static createProperty(name, options) {
   *   options = Object.assign(options, {myOption: true});
   *   super.createProperty(name, options);
   * }
   * ```
   *
   * @nocollapse
   * @category properties
   */
  static createProperty(e, t = Se) {
    if (t.state && (t.attribute = !1), this.__prepare(), this.elementProperties.set(e, t), !t.noAccessor) {
      const n = (
        // Use Symbol.for in dev mode to make it easier to maintain state
        // when doing HMR.
        Symbol.for(`${String(e)} (@property() cache)`)
      ), s = this.getPropertyDescriptor(e, n, t);
      s !== void 0 && Ke(this.prototype, e, s);
    }
  }
  /**
   * Returns a property descriptor to be defined on the given named property.
   * If no descriptor is returned, the property will not become an accessor.
   * For example,
   *
   * ```ts
   * class MyElement extends LitElement {
   *   static getPropertyDescriptor(name, key, options) {
   *     const defaultDescriptor =
   *         super.getPropertyDescriptor(name, key, options);
   *     const setter = defaultDescriptor.set;
   *     return {
   *       get: defaultDescriptor.get,
   *       set(value) {
   *         setter.call(this, value);
   *         // custom action.
   *       },
   *       configurable: true,
   *       enumerable: true
   *     }
   *   }
   * }
   * ```
   *
   * @nocollapse
   * @category properties
   */
  static getPropertyDescriptor(e, t, n) {
    const { get: s, set: r } = be(this.prototype, e) ?? {
      get() {
        return this[t];
      },
      set(o) {
        this[t] = o;
      }
    };
    if (s == null) {
      if ("value" in (be(this.prototype, e) ?? {}))
        throw new Error(`Field ${JSON.stringify(String(e))} on ${this.name} was declared as a reactive property but it's actually declared as a value on the prototype. Usually this is due to using @property or @state on a method.`);
      $("reactive-property-without-getter", `Field ${JSON.stringify(String(e))} on ${this.name} was declared as a reactive property but it does not have a getter. This will be an error in a future version of Lit.`);
    }
    return {
      get() {
        return s == null ? void 0 : s.call(this);
      },
      set(o) {
        const c = s == null ? void 0 : s.call(this);
        r.call(this, o), this.requestUpdate(e, c, n);
      },
      configurable: !0,
      enumerable: !0
    };
  }
  /**
   * Returns the property options associated with the given property.
   * These options are defined with a `PropertyDeclaration` via the `properties`
   * object or the `@property` decorator and are registered in
   * `createProperty(...)`.
   *
   * Note, this method should be considered "final" and not overridden. To
   * customize the options for a given property, override
   * {@linkcode createProperty}.
   *
   * @nocollapse
   * @final
   * @category properties
   */
  static getPropertyOptions(e) {
    return this.elementProperties.get(e) ?? Se;
  }
  /**
   * Initializes static own properties of the class used in bookkeeping
   * for element properties, initializers, etc.
   *
   * Can be called multiple times by code that needs to ensure these
   * properties exist before using them.
   *
   * This method ensures the superclass is finalized so that inherited
   * property metadata can be copied down.
   * @nocollapse
   */
  static __prepare() {
    if (this.hasOwnProperty(N("elementProperties")))
      return;
    const e = $e(this);
    e.finalize(), e._initializers !== void 0 && (this._initializers = [...e._initializers]), this.elementProperties = new Map(e.elementProperties);
  }
  /**
   * Finishes setting up the class so that it's ready to be registered
   * as a custom element and instantiated.
   *
   * This method is called by the ReactiveElement.observedAttributes getter.
   * If you override the observedAttributes getter, you must either call
   * super.observedAttributes to trigger finalization, or call finalize()
   * yourself.
   *
   * @nocollapse
   */
  static finalize() {
    if (this.hasOwnProperty(N("finalized")))
      return;
    if (this.finalized = !0, this.__prepare(), this.hasOwnProperty(N("properties"))) {
      const t = this.properties, n = [
        ...Xe(t),
        ...et(t)
      ];
      for (const s of n)
        this.createProperty(s, t[s]);
    }
    const e = this[Symbol.metadata];
    if (e !== null) {
      const t = litPropertyMetadata.get(e);
      if (t !== void 0)
        for (const [n, s] of t)
          this.elementProperties.set(n, s);
    }
    this.__attributeToPropertyMap = /* @__PURE__ */ new Map();
    for (const [t, n] of this.elementProperties) {
      const s = this.__attributeNameForProperty(t, n);
      s !== void 0 && this.__attributeToPropertyMap.set(s, t);
    }
    this.elementStyles = this.finalizeStyles(this.styles), this.hasOwnProperty("createProperty") && $("no-override-create-property", "Overriding ReactiveElement.createProperty() is deprecated. The override will not be called with standard decorators"), this.hasOwnProperty("getPropertyDescriptor") && $("no-override-get-property-descriptor", "Overriding ReactiveElement.getPropertyDescriptor() is deprecated. The override will not be called with standard decorators");
  }
  /**
   * Takes the styles the user supplied via the `static styles` property and
   * returns the array of styles to apply to the element.
   * Override this method to integrate into a style management system.
   *
   * Styles are deduplicated preserving the _last_ instance in the list. This
   * is a performance optimization to avoid duplicated styles that can occur
   * especially when composing via subclassing. The last item is kept to try
   * to preserve the cascade order with the assumption that it's most important
   * that last added styles override previous styles.
   *
   * @nocollapse
   * @category styles
   */
  static finalizeStyles(e) {
    const t = [];
    if (Array.isArray(e)) {
      const n = new Set(e.flat(1 / 0).reverse());
      for (const s of n)
        t.unshift(ye(s));
    } else e !== void 0 && t.push(ye(e));
    return t;
  }
  /**
   * Returns the property name for the given attribute `name`.
   * @nocollapse
   */
  static __attributeNameForProperty(e, t) {
    const n = t.attribute;
    return n === !1 ? void 0 : typeof n == "string" ? n : typeof e == "string" ? e.toLowerCase() : void 0;
  }
  constructor() {
    super(), this.__instanceProperties = void 0, this.isUpdatePending = !1, this.hasUpdated = !1, this.__reflectingProperty = null, this.__initialize();
  }
  /**
   * Internal only override point for customizing work done when elements
   * are constructed.
   */
  __initialize() {
    var e;
    this.__updatePromise = new Promise((t) => this.enableUpdating = t), this._$changedProperties = /* @__PURE__ */ new Map(), this.__saveInstanceProperties(), this.requestUpdate(), (e = this.constructor._initializers) == null || e.forEach((t) => t(this));
  }
  /**
   * Registers a `ReactiveController` to participate in the element's reactive
   * update cycle. The element automatically calls into any registered
   * controllers during its lifecycle callbacks.
   *
   * If the element is connected when `addController()` is called, the
   * controller's `hostConnected()` callback will be immediately called.
   * @category controllers
   */
  addController(e) {
    var t;
    (this.__controllers ?? (this.__controllers = /* @__PURE__ */ new Set())).add(e), this.renderRoot !== void 0 && this.isConnected && ((t = e.hostConnected) == null || t.call(e));
  }
  /**
   * Removes a `ReactiveController` from the element.
   * @category controllers
   */
  removeController(e) {
    var t;
    (t = this.__controllers) == null || t.delete(e);
  }
  /**
   * Fixes any properties set on the instance before upgrade time.
   * Otherwise these would shadow the accessor and break these properties.
   * The properties are stored in a Map which is played back after the
   * constructor runs. Note, on very old versions of Safari (<=9) or Chrome
   * (<=41), properties created for native platform properties like (`id` or
   * `name`) may not have default values set in the element constructor. On
   * these browsers native properties appear on instances and therefore their
   * default value will overwrite any element default (e.g. if the element sets
   * this.id = 'id' in the constructor, the 'id' will become '' since this is
   * the native platform default).
   */
  __saveInstanceProperties() {
    const e = /* @__PURE__ */ new Map(), t = this.constructor.elementProperties;
    for (const n of t.keys())
      this.hasOwnProperty(n) && (e.set(n, this[n]), delete this[n]);
    e.size > 0 && (this.__instanceProperties = e);
  }
  /**
   * Returns the node into which the element should render and by default
   * creates and returns an open shadowRoot. Implement to customize where the
   * element's DOM is rendered. For example, to render into the element's
   * childNodes, return `this`.
   *
   * @return Returns a node into which to render.
   * @category rendering
   */
  createRenderRoot() {
    const e = this.shadowRoot ?? this.attachShadow(this.constructor.shadowRootOptions);
    return Qe(e, this.constructor.elementStyles), e;
  }
  /**
   * On first connection, creates the element's renderRoot, sets up
   * element styling, and enables updating.
   * @category lifecycle
   */
  connectedCallback() {
    var e;
    this.renderRoot ?? (this.renderRoot = this.createRenderRoot()), this.enableUpdating(!0), (e = this.__controllers) == null || e.forEach((t) => {
      var n;
      return (n = t.hostConnected) == null ? void 0 : n.call(t);
    });
  }
  /**
   * Note, this method should be considered final and not overridden. It is
   * overridden on the element instance with a function that triggers the first
   * update.
   * @category updates
   */
  enableUpdating(e) {
  }
  /**
   * Allows for `super.disconnectedCallback()` in extensions while
   * reserving the possibility of making non-breaking feature additions
   * when disconnecting at some point in the future.
   * @category lifecycle
   */
  disconnectedCallback() {
    var e;
    (e = this.__controllers) == null || e.forEach((t) => {
      var n;
      return (n = t.hostDisconnected) == null ? void 0 : n.call(t);
    });
  }
  /**
   * Synchronizes property values when attributes change.
   *
   * Specifically, when an attribute is set, the corresponding property is set.
   * You should rarely need to implement this callback. If this method is
   * overridden, `super.attributeChangedCallback(name, _old, value)` must be
   * called.
   *
   * See [using the lifecycle callbacks](https://developer.mozilla.org/en-US/docs/Web/Web_Components/Using_custom_elements#using_the_lifecycle_callbacks)
   * on MDN for more information about the `attributeChangedCallback`.
   * @category attributes
   */
  attributeChangedCallback(e, t, n) {
    this._$attributeToProperty(e, n);
  }
  __propertyToAttribute(e, t) {
    var o;
    const s = this.constructor.elementProperties.get(e), r = this.constructor.__attributeNameForProperty(e, s);
    if (r !== void 0 && s.reflect === !0) {
      const a = (((o = s.converter) == null ? void 0 : o.toAttribute) !== void 0 ? s.converter : Y).toAttribute(t, s.type);
      this.constructor.enabledWarnings.includes("migration") && a === void 0 && $("undefined-attribute-value", `The attribute value for the ${e} property is undefined on element ${this.localName}. The attribute will be removed, but in the previous version of \`ReactiveElement\`, the attribute would not have changed.`), this.__reflectingProperty = e, a == null ? this.removeAttribute(r) : this.setAttribute(r, a), this.__reflectingProperty = null;
    }
  }
  /** @internal */
  _$attributeToProperty(e, t) {
    var r;
    const n = this.constructor, s = n.__attributeToPropertyMap.get(e);
    if (s !== void 0 && this.__reflectingProperty !== s) {
      const o = n.getPropertyOptions(s), c = typeof o.converter == "function" ? { fromAttribute: o.converter } : ((r = o.converter) == null ? void 0 : r.fromAttribute) !== void 0 ? o.converter : Y;
      this.__reflectingProperty = s, this[s] = c.fromAttribute(
        t,
        o.type
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
      ), this.__reflectingProperty = null;
    }
  }
  /**
   * Requests an update which is processed asynchronously. This should be called
   * when an element should update based on some state not triggered by setting
   * a reactive property. In this case, pass no arguments. It should also be
   * called when manually implementing a property setter. In this case, pass the
   * property `name` and `oldValue` to ensure that any configured property
   * options are honored.
   *
   * @param name name of requesting property
   * @param oldValue old value of requesting property
   * @param options property options to use instead of the previously
   *     configured options
   * @category updates
   */
  requestUpdate(e, t, n) {
    if (e !== void 0) {
      e instanceof Event && $("", "The requestUpdate() method was called with an Event as the property name. This is probably a mistake caused by binding this.requestUpdate as an event listener. Instead bind a function that will call it with no arguments: () => this.requestUpdate()"), n ?? (n = this.constructor.getPropertyOptions(e));
      const s = n.hasChanged ?? ue, r = this[e];
      if (s(r, t))
        this._$changeProperty(e, t, n);
      else
        return;
    }
    this.isUpdatePending === !1 && (this.__updatePromise = this.__enqueueUpdate());
  }
  /**
   * @internal
   */
  _$changeProperty(e, t, n) {
    this._$changedProperties.has(e) || this._$changedProperties.set(e, t), n.reflect === !0 && this.__reflectingProperty !== e && (this.__reflectingProperties ?? (this.__reflectingProperties = /* @__PURE__ */ new Set())).add(e);
  }
  /**
   * Sets up the element to asynchronously update.
   */
  async __enqueueUpdate() {
    this.isUpdatePending = !0;
    try {
      await this.__updatePromise;
    } catch (t) {
      Promise.reject(t);
    }
    const e = this.scheduleUpdate();
    return e != null && await e, !this.isUpdatePending;
  }
  /**
   * Schedules an element update. You can override this method to change the
   * timing of updates by returning a Promise. The update will await the
   * returned Promise, and you should resolve the Promise to allow the update
   * to proceed. If this method is overridden, `super.scheduleUpdate()`
   * must be called.
   *
   * For instance, to schedule updates to occur just before the next frame:
   *
   * ```ts
   * override protected async scheduleUpdate(): Promise<unknown> {
   *   await new Promise((resolve) => requestAnimationFrame(() => resolve()));
   *   super.scheduleUpdate();
   * }
   * ```
   * @category updates
   */
  scheduleUpdate() {
    const e = this.performUpdate();
    return this.constructor.enabledWarnings.includes("async-perform-update") && typeof (e == null ? void 0 : e.then) == "function" && $("async-perform-update", `Element ${this.localName} returned a Promise from performUpdate(). This behavior is deprecated and will be removed in a future version of ReactiveElement.`), e;
  }
  /**
   * Performs an element update. Note, if an exception is thrown during the
   * update, `firstUpdated` and `updated` will not be called.
   *
   * Call `performUpdate()` to immediately process a pending update. This should
   * generally not be needed, but it can be done in rare cases when you need to
   * update synchronously.
   *
   * @category updates
   */
  performUpdate() {
    var n;
    if (!this.isUpdatePending)
      return;
    if (X == null || X({ kind: "update" }), !this.hasUpdated) {
      this.renderRoot ?? (this.renderRoot = this.createRenderRoot());
      {
        const o = [...this.constructor.elementProperties.keys()].filter((c) => this.hasOwnProperty(c) && c in $e(this));
        if (o.length)
          throw new Error(`The following properties on element ${this.localName} will not trigger updates as expected because they are set using class fields: ${o.join(", ")}. Native class fields and some compiled output will overwrite accessors used for detecting changes. See https://lit.dev/msg/class-field-shadowing for more information.`);
      }
      if (this.__instanceProperties) {
        for (const [r, o] of this.__instanceProperties)
          this[r] = o;
        this.__instanceProperties = void 0;
      }
      const s = this.constructor.elementProperties;
      if (s.size > 0)
        for (const [r, o] of s)
          o.wrapped === !0 && !this._$changedProperties.has(r) && this[r] !== void 0 && this._$changeProperty(r, this[r], o);
    }
    let e = !1;
    const t = this._$changedProperties;
    try {
      e = this.shouldUpdate(t), e ? (this.willUpdate(t), (n = this.__controllers) == null || n.forEach((s) => {
        var r;
        return (r = s.hostUpdate) == null ? void 0 : r.call(s);
      }), this.update(t)) : this.__markUpdated();
    } catch (s) {
      throw e = !1, this.__markUpdated(), s;
    }
    e && this._$didUpdate(t);
  }
  /**
   * Invoked before `update()` to compute values needed during the update.
   *
   * Implement `willUpdate` to compute property values that depend on other
   * properties and are used in the rest of the update process.
   *
   * ```ts
   * willUpdate(changedProperties) {
   *   // only need to check changed properties for an expensive computation.
   *   if (changedProperties.has('firstName') || changedProperties.has('lastName')) {
   *     this.sha = computeSHA(`${this.firstName} ${this.lastName}`);
   *   }
   * }
   *
   * render() {
   *   return html`SHA: ${this.sha}`;
   * }
   * ```
   *
   * @category updates
   */
  willUpdate(e) {
  }
  // Note, this is an override point for polyfill-support.
  // @internal
  _$didUpdate(e) {
    var t;
    (t = this.__controllers) == null || t.forEach((n) => {
      var s;
      return (s = n.hostUpdated) == null ? void 0 : s.call(n);
    }), this.hasUpdated || (this.hasUpdated = !0, this.firstUpdated(e)), this.updated(e), this.isUpdatePending && this.constructor.enabledWarnings.includes("change-in-update") && $("change-in-update", `Element ${this.localName} scheduled an update (generally because a property was set) after an update completed, causing a new update to be scheduled. This is inefficient and should be avoided unless the next update can only be scheduled as a side effect of the previous update.`);
  }
  __markUpdated() {
    this._$changedProperties = /* @__PURE__ */ new Map(), this.isUpdatePending = !1;
  }
  /**
   * Returns a Promise that resolves when the element has completed updating.
   * The Promise value is a boolean that is `true` if the element completed the
   * update without triggering another update. The Promise result is `false` if
   * a property was set inside `updated()`. If the Promise is rejected, an
   * exception was thrown during the update.
   *
   * To await additional asynchronous work, override the `getUpdateComplete`
   * method. For example, it is sometimes useful to await a rendered element
   * before fulfilling this Promise. To do this, first await
   * `super.getUpdateComplete()`, then any subsequent state.
   *
   * @return A promise of a boolean that resolves to true if the update completed
   *     without triggering another update.
   * @category updates
   */
  get updateComplete() {
    return this.getUpdateComplete();
  }
  /**
   * Override point for the `updateComplete` promise.
   *
   * It is not safe to override the `updateComplete` getter directly due to a
   * limitation in TypeScript which means it is not possible to call a
   * superclass getter (e.g. `super.updateComplete.then(...)`) when the target
   * language is ES5 (https://github.com/microsoft/TypeScript/issues/338).
   * This method should be overridden instead. For example:
   *
   * ```ts
   * class MyElement extends LitElement {
   *   override async getUpdateComplete() {
   *     const result = await super.getUpdateComplete();
   *     await this._myChild.updateComplete;
   *     return result;
   *   }
   * }
   * ```
   *
   * @return A promise of a boolean that resolves to true if the update completed
   *     without triggering another update.
   * @category updates
   */
  getUpdateComplete() {
    return this.__updatePromise;
  }
  /**
   * Controls whether or not `update()` should be called when the element requests
   * an update. By default, this method always returns `true`, but this can be
   * customized to control when to update.
   *
   * @param _changedProperties Map of changed properties with old values
   * @category updates
   */
  shouldUpdate(e) {
    return !0;
  }
  /**
   * Updates the element. This method reflects property values to attributes.
   * It can be overridden to render and keep updated element DOM.
   * Setting properties inside this method will *not* trigger
   * another update.
   *
   * @param _changedProperties Map of changed properties with old values
   * @category updates
   */
  update(e) {
    this.__reflectingProperties && (this.__reflectingProperties = this.__reflectingProperties.forEach((t) => this.__propertyToAttribute(t, this[t]))), this.__markUpdated();
  }
  /**
   * Invoked whenever the element is updated. Implement to perform
   * post-updating tasks via DOM APIs, for example, focusing an element.
   *
   * Setting properties inside this method will trigger the element to update
   * again after this update cycle completes.
   *
   * @param _changedProperties Map of changed properties with old values
   * @category updates
   */
  updated(e) {
  }
  /**
   * Invoked when the element is first updated. Implement to perform one time
   * work on the element after update.
   *
   * ```ts
   * firstUpdated() {
   *   this.renderRoot.getElementById('my-text-area').focus();
   * }
   * ```
   *
   * Setting properties inside this method will trigger the element to update
   * again after this update cycle completes.
   *
   * @param _changedProperties Map of changed properties with old values
   * @category updates
   */
  firstUpdated(e) {
  }
}
P.elementStyles = [];
P.shadowRootOptions = { mode: "open" };
P[N("elementProperties")] = /* @__PURE__ */ new Map();
P[N("finalized")] = /* @__PURE__ */ new Map();
q == null || q({ ReactiveElement: P });
{
  P.enabledWarnings = [
    "change-in-update",
    "async-perform-update"
  ];
  const i = function(e) {
    e.hasOwnProperty(N("enabledWarnings")) || (e.enabledWarnings = e.enabledWarnings.slice());
  };
  P.enableWarning = function(e) {
    i(this), this.enabledWarnings.includes(e) || this.enabledWarnings.push(e);
  }, P.disableWarning = function(e) {
    i(this);
    const t = this.enabledWarnings.indexOf(e);
    t >= 0 && this.enabledWarnings.splice(t, 1);
  };
}
(g.reactiveElementVersions ?? (g.reactiveElementVersions = [])).push("2.0.4");
g.reactiveElementVersions.length > 1 && $("multiple-versions", "Multiple versions of Lit loaded. Loading multiple versions is not recommended.");
/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
const _ = globalThis, d = (i) => {
  _.emitLitDebugLogEvents && _.dispatchEvent(new CustomEvent("lit-debug", {
    detail: i
  }));
};
let it = 0, k;
_.litIssuedWarnings ?? (_.litIssuedWarnings = /* @__PURE__ */ new Set()), k = (i, e) => {
  e += i ? ` See https://lit.dev/msg/${i} for more information.` : "", _.litIssuedWarnings.has(e) || (console.warn(e), _.litIssuedWarnings.add(e));
}, k("dev-mode", "Lit is in dev mode. Not recommended for production!");
var Ue, Me;
const b = (Ue = _.ShadyDOM) != null && Ue.inUse && ((Me = _.ShadyDOM) == null ? void 0 : Me.noPatch) === !0 ? _.ShadyDOM.wrap : (i) => i, G = _.trustedTypes, Pe = G ? G.createPolicy("lit-html", {
  createHTML: (i) => i
}) : void 0, nt = (i) => i, j = (i, e, t) => nt, st = (i) => {
  if (x !== j)
    throw new Error("Attempted to overwrite existing lit-html security policy. setSanitizeDOMValueFactory should be called at most once.");
  x = i;
}, rt = () => {
  x = j;
}, de = (i, e, t) => x(i, e, t), De = "$lit$", S = `lit$${Math.random().toFixed(9).slice(2)}$`, ze = "?" + S, ot = `<${ze}>`, T = document, V = () => T.createComment(""), O = (i) => i === null || typeof i != "object" && typeof i != "function", fe = Array.isArray, at = (i) => fe(i) || // eslint-disable-next-line @typescript-eslint/no-explicit-any
typeof (i == null ? void 0 : i[Symbol.iterator]) == "function", ee = `[ 	
\f\r]`, dt = `[^ 	
\f\r"'\`<>=]`, ct = `[^\\s"'>=/]`, U = /<(?:(!--|\/[^a-zA-Z])|(\/?[a-zA-Z][^>\s]*)|(\/?$))/g, Ee = 1, te = 2, lt = 3, Ce = /-->/g, Te = />/g, E = new RegExp(`>|${ee}(?:(${ct}+)(${ee}*=${ee}*(?:${dt}|("|')|))|$)`, "g"), ht = 0, xe = 1, pt = 2, Ne = 3, ie = /'/g, ne = /"/g, Le = /^(?:script|style|textarea|title)$/i, ut = 1, ce = 2, le = 3, me = 1, Q = 2, ft = 3, mt = 4, _t = 5, _e = 6, gt = 7, yt = (i) => (e, ...t) => (e.some((n) => n === void 0) && console.warn(`Some template strings are undefined.
This is probably caused by illegal octal escape sequences.`), t.some((n) => n == null ? void 0 : n._$litStatic$) && k("", `Static values 'literal' or 'unsafeStatic' cannot be used as values to non-static templates.
Please use the static 'html' tag function. See https://lit.dev/docs/templates/expressions/#static-expressions`), {
  // This property needs to remain unminified.
  _$litType$: i,
  strings: e,
  values: t
}), bt = yt(ut), R = Symbol.for("lit-noChange"), p = Symbol.for("lit-nothing"), Re = /* @__PURE__ */ new WeakMap(), C = T.createTreeWalker(
  T,
  129
  /* NodeFilter.SHOW_{ELEMENT|COMMENT} */
);
let x = j;
function We(i, e) {
  if (!fe(i) || !i.hasOwnProperty("raw")) {
    let t = "invalid template strings array";
    throw t = `
          Internal Error: expected template strings to be an array
          with a 'raw' field. Faking a template strings array by
          calling html or svg like an ordinary function is effectively
          the same as calling unsafeHtml and can lead to major security
          issues, e.g. opening your code up to XSS attacks.
          If you're using the html or svg tagged template functions normally
          and still seeing this error, please file a bug at
          https://github.com/lit/lit/issues/new?template=bug_report.md
          and include information about your build tooling, if any.
        `.trim().replace(/\n */g, `
`), new Error(t);
  }
  return Pe !== void 0 ? Pe.createHTML(e) : e;
}
const $t = (i, e) => {
  const t = i.length - 1, n = [];
  let s = e === ce ? "<svg>" : e === le ? "<math>" : "", r, o = U;
  for (let a = 0; a < t; a++) {
    const l = i[a];
    let y = -1, h, m = 0, u;
    for (; m < l.length && (o.lastIndex = m, u = o.exec(l), u !== null); )
      if (m = o.lastIndex, o === U) {
        if (u[Ee] === "!--")
          o = Ce;
        else if (u[Ee] !== void 0)
          o = Te;
        else if (u[te] !== void 0)
          Le.test(u[te]) && (r = new RegExp(`</${u[te]}`, "g")), o = E;
        else if (u[lt] !== void 0)
          throw new Error("Bindings in tag names are not supported. Please use static templates instead. See https://lit.dev/docs/templates/expressions/#static-expressions");
      } else o === E ? u[ht] === ">" ? (o = r ?? U, y = -1) : u[xe] === void 0 ? y = -2 : (y = o.lastIndex - u[pt].length, h = u[xe], o = u[Ne] === void 0 ? E : u[Ne] === '"' ? ne : ie) : o === ne || o === ie ? o = E : o === Ce || o === Te ? o = U : (o = E, r = void 0);
    console.assert(y === -1 || o === E || o === ie || o === ne, "unexpected parse state B");
    const W = o === E && i[a + 1].startsWith("/>") ? " " : "";
    s += o === U ? l + ot : y >= 0 ? (n.push(h), l.slice(0, y) + De + l.slice(y) + S + W) : l + S + (y === -2 ? a : W);
  }
  const c = s + (i[t] || "<?>") + (e === ce ? "</svg>" : e === le ? "</math>" : "");
  return [We(i, c), n];
};
class I {
  constructor({ strings: e, ["_$litType$"]: t }, n) {
    this.parts = [];
    let s, r = 0, o = 0;
    const c = e.length - 1, a = this.parts, [l, y] = $t(e, t);
    if (this.el = I.createElement(l, n), C.currentNode = this.el.content, t === ce || t === le) {
      const h = this.el.content.firstChild;
      h.replaceWith(...h.childNodes);
    }
    for (; (s = C.nextNode()) !== null && a.length < c; ) {
      if (s.nodeType === 1) {
        {
          const h = s.localName;
          if (/^(?:textarea|template)$/i.test(h) && s.innerHTML.includes(S)) {
            const m = `Expressions are not supported inside \`${h}\` elements. See https://lit.dev/msg/expression-in-${h} for more information.`;
            if (h === "template")
              throw new Error(m);
            k("", m);
          }
        }
        if (s.hasAttributes())
          for (const h of s.getAttributeNames())
            if (h.endsWith(De)) {
              const m = y[o++], W = s.getAttribute(h).split(S), H = /([.?@])?(.*)/.exec(m);
              a.push({
                type: me,
                index: r,
                name: H[2],
                strings: W,
                ctor: H[1] === "." ? St : H[1] === "?" ? Pt : H[1] === "@" ? Et : K
              }), s.removeAttribute(h);
            } else h.startsWith(S) && (a.push({
              type: _e,
              index: r
            }), s.removeAttribute(h));
        if (Le.test(s.tagName)) {
          const h = s.textContent.split(S), m = h.length - 1;
          if (m > 0) {
            s.textContent = G ? G.emptyScript : "";
            for (let u = 0; u < m; u++)
              s.append(h[u], V()), C.nextNode(), a.push({ type: Q, index: ++r });
            s.append(h[m], V());
          }
        }
      } else if (s.nodeType === 8)
        if (s.data === ze)
          a.push({ type: Q, index: r });
        else {
          let m = -1;
          for (; (m = s.data.indexOf(S, m + 1)) !== -1; )
            a.push({ type: gt, index: r }), m += S.length - 1;
        }
      r++;
    }
    if (y.length !== o)
      throw new Error('Detected duplicate attribute bindings. This occurs if your template has duplicate attributes on an element tag. For example "<input ?disabled=${true} ?disabled=${false}>" contains a duplicate "disabled" attribute. The error was detected in the following template: \n`' + e.join("${...}") + "`");
    d && d({
      kind: "template prep",
      template: this,
      clonableTemplate: this.el,
      parts: this.parts,
      strings: e
    });
  }
  // Overridden via `litHtmlPolyfillSupport` to provide platform support.
  /** @nocollapse */
  static createElement(e, t) {
    const n = T.createElement("template");
    return n.innerHTML = e, n;
  }
}
function v(i, e, t = i, n) {
  var o, c;
  if (e === R)
    return e;
  let s = n !== void 0 ? (o = t.__directives) == null ? void 0 : o[n] : t.__directive;
  const r = O(e) ? void 0 : (
    // This property needs to remain unminified.
    e._$litDirective$
  );
  return (s == null ? void 0 : s.constructor) !== r && ((c = s == null ? void 0 : s._$notifyDirectiveConnectionChanged) == null || c.call(s, !1), r === void 0 ? s = void 0 : (s = new r(i), s._$initialize(i, t, n)), n !== void 0 ? (t.__directives ?? (t.__directives = []))[n] = s : t.__directive = s), s !== void 0 && (e = v(i, s._$resolve(i, e.values), s, n)), e;
}
class wt {
  constructor(e, t) {
    this._$parts = [], this._$disconnectableChildren = void 0, this._$template = e, this._$parent = t;
  }
  // Called by ChildPart parentNode getter
  get parentNode() {
    return this._$parent.parentNode;
  }
  // See comment in Disconnectable interface for why this is a getter
  get _$isConnected() {
    return this._$parent._$isConnected;
  }
  // This method is separate from the constructor because we need to return a
  // DocumentFragment and we don't want to hold onto it with an instance field.
  _clone(e) {
    const { el: { content: t }, parts: n } = this._$template, s = ((e == null ? void 0 : e.creationScope) ?? T).importNode(t, !0);
    C.currentNode = s;
    let r = C.nextNode(), o = 0, c = 0, a = n[0];
    for (; a !== void 0; ) {
      if (o === a.index) {
        let l;
        a.type === Q ? l = new D(r, r.nextSibling, this, e) : a.type === me ? l = new a.ctor(r, a.name, a.strings, this, e) : a.type === _e && (l = new Ct(r, this, e)), this._$parts.push(l), a = n[++c];
      }
      o !== (a == null ? void 0 : a.index) && (r = C.nextNode(), o++);
    }
    return C.currentNode = T, s;
  }
  _update(e) {
    let t = 0;
    for (const n of this._$parts)
      n !== void 0 && (d && d({
        kind: "set part",
        part: n,
        value: e[t],
        valueIndex: t,
        values: e,
        templateInstance: this
      }), n.strings !== void 0 ? (n._$setValue(e, n, t), t += n.strings.length - 2) : n._$setValue(e[t])), t++;
  }
}
class D {
  // See comment in Disconnectable interface for why this is a getter
  get _$isConnected() {
    var e;
    return ((e = this._$parent) == null ? void 0 : e._$isConnected) ?? this.__isConnected;
  }
  constructor(e, t, n, s) {
    this.type = Q, this._$committedValue = p, this._$disconnectableChildren = void 0, this._$startNode = e, this._$endNode = t, this._$parent = n, this.options = s, this.__isConnected = (s == null ? void 0 : s.isConnected) ?? !0, this._textSanitizer = void 0;
  }
  /**
   * The parent node into which the part renders its content.
   *
   * A ChildPart's content consists of a range of adjacent child nodes of
   * `.parentNode`, possibly bordered by 'marker nodes' (`.startNode` and
   * `.endNode`).
   *
   * - If both `.startNode` and `.endNode` are non-null, then the part's content
   * consists of all siblings between `.startNode` and `.endNode`, exclusively.
   *
   * - If `.startNode` is non-null but `.endNode` is null, then the part's
   * content consists of all siblings following `.startNode`, up to and
   * including the last child of `.parentNode`. If `.endNode` is non-null, then
   * `.startNode` will always be non-null.
   *
   * - If both `.endNode` and `.startNode` are null, then the part's content
   * consists of all child nodes of `.parentNode`.
   */
  get parentNode() {
    let e = b(this._$startNode).parentNode;
    const t = this._$parent;
    return t !== void 0 && (e == null ? void 0 : e.nodeType) === 11 && (e = t.parentNode), e;
  }
  /**
   * The part's leading marker node, if any. See `.parentNode` for more
   * information.
   */
  get startNode() {
    return this._$startNode;
  }
  /**
   * The part's trailing marker node, if any. See `.parentNode` for more
   * information.
   */
  get endNode() {
    return this._$endNode;
  }
  _$setValue(e, t = this) {
    var n;
    if (this.parentNode === null)
      throw new Error("This `ChildPart` has no `parentNode` and therefore cannot accept a value. This likely means the element containing the part was manipulated in an unsupported way outside of Lit's control such that the part's marker nodes were ejected from DOM. For example, setting the element's `innerHTML` or `textContent` can do this.");
    if (e = v(this, e, t), O(e))
      e === p || e == null || e === "" ? (this._$committedValue !== p && (d && d({
        kind: "commit nothing to child",
        start: this._$startNode,
        end: this._$endNode,
        parent: this._$parent,
        options: this.options
      }), this._$clear()), this._$committedValue = p) : e !== this._$committedValue && e !== R && this._commitText(e);
    else if (e._$litType$ !== void 0)
      this._commitTemplateResult(e);
    else if (e.nodeType !== void 0) {
      if (((n = this.options) == null ? void 0 : n.host) === e) {
        this._commitText("[probable mistake: rendered a template's host in itself (commonly caused by writing ${this} in a template]"), console.warn("Attempted to render the template host", e, "inside itself. This is almost always a mistake, and in dev mode ", "we render some warning text. In production however, we'll ", "render it, which will usually result in an error, and sometimes ", "in the element disappearing from the DOM.");
        return;
      }
      this._commitNode(e);
    } else at(e) ? this._commitIterable(e) : this._commitText(e);
  }
  _insert(e) {
    return b(b(this._$startNode).parentNode).insertBefore(e, this._$endNode);
  }
  _commitNode(e) {
    var t;
    if (this._$committedValue !== e) {
      if (this._$clear(), x !== j) {
        const n = (t = this._$startNode.parentNode) == null ? void 0 : t.nodeName;
        if (n === "STYLE" || n === "SCRIPT") {
          let s = "Forbidden";
          throw n === "STYLE" ? s = "Lit does not support binding inside style nodes. This is a security risk, as style injection attacks can exfiltrate data and spoof UIs. Consider instead using css`...` literals to compose styles, and do dynamic styling with css custom properties, ::parts, <slot>s, and by mutating the DOM rather than stylesheets." : s = "Lit does not support binding inside script nodes. This is a security risk, as it could allow arbitrary code execution.", new Error(s);
        }
      }
      d && d({
        kind: "commit node",
        start: this._$startNode,
        parent: this._$parent,
        value: e,
        options: this.options
      }), this._$committedValue = this._insert(e);
    }
  }
  _commitText(e) {
    if (this._$committedValue !== p && O(this._$committedValue)) {
      const t = b(this._$startNode).nextSibling;
      this._textSanitizer === void 0 && (this._textSanitizer = de(t, "data", "property")), e = this._textSanitizer(e), d && d({
        kind: "commit text",
        node: t,
        value: e,
        options: this.options
      }), t.data = e;
    } else {
      const t = T.createTextNode("");
      this._commitNode(t), this._textSanitizer === void 0 && (this._textSanitizer = de(t, "data", "property")), e = this._textSanitizer(e), d && d({
        kind: "commit text",
        node: t,
        value: e,
        options: this.options
      }), t.data = e;
    }
    this._$committedValue = e;
  }
  _commitTemplateResult(e) {
    var r;
    const { values: t, ["_$litType$"]: n } = e, s = typeof n == "number" ? this._$getTemplate(e) : (n.el === void 0 && (n.el = I.createElement(We(n.h, n.h[0]), this.options)), n);
    if (((r = this._$committedValue) == null ? void 0 : r._$template) === s)
      d && d({
        kind: "template updating",
        template: s,
        instance: this._$committedValue,
        parts: this._$committedValue._$parts,
        options: this.options,
        values: t
      }), this._$committedValue._update(t);
    else {
      const o = new wt(s, this), c = o._clone(this.options);
      d && d({
        kind: "template instantiated",
        template: s,
        instance: o,
        parts: o._$parts,
        options: this.options,
        fragment: c,
        values: t
      }), o._update(t), d && d({
        kind: "template instantiated and updated",
        template: s,
        instance: o,
        parts: o._$parts,
        options: this.options,
        fragment: c,
        values: t
      }), this._commitNode(c), this._$committedValue = o;
    }
  }
  // Overridden via `litHtmlPolyfillSupport` to provide platform support.
  /** @internal */
  _$getTemplate(e) {
    let t = Re.get(e.strings);
    return t === void 0 && Re.set(e.strings, t = new I(e)), t;
  }
  _commitIterable(e) {
    fe(this._$committedValue) || (this._$committedValue = [], this._$clear());
    const t = this._$committedValue;
    let n = 0, s;
    for (const r of e)
      n === t.length ? t.push(s = new D(this._insert(V()), this._insert(V()), this, this.options)) : s = t[n], s._$setValue(r), n++;
    n < t.length && (this._$clear(s && b(s._$endNode).nextSibling, n), t.length = n);
  }
  /**
   * Removes the nodes contained within this Part from the DOM.
   *
   * @param start Start node to clear from, for clearing a subset of the part's
   *     DOM (used when truncating iterables)
   * @param from  When `start` is specified, the index within the iterable from
   *     which ChildParts are being removed, used for disconnecting directives in
   *     those Parts.
   *
   * @internal
   */
  _$clear(e = b(this._$startNode).nextSibling, t) {
    var n;
    for ((n = this._$notifyConnectionChanged) == null || n.call(this, !1, !0, t); e && e !== this._$endNode; ) {
      const s = b(e).nextSibling;
      b(e).remove(), e = s;
    }
  }
  /**
   * Implementation of RootPart's `isConnected`. Note that this method
   * should only be called on `RootPart`s (the `ChildPart` returned from a
   * top-level `render()` call). It has no effect on non-root ChildParts.
   * @param isConnected Whether to set
   * @internal
   */
  setConnected(e) {
    var t;
    if (this._$parent === void 0)
      this.__isConnected = e, (t = this._$notifyConnectionChanged) == null || t.call(this, e);
    else
      throw new Error("part.setConnected() may only be called on a RootPart returned from render().");
  }
}
class K {
  get tagName() {
    return this.element.tagName;
  }
  // See comment in Disconnectable interface for why this is a getter
  get _$isConnected() {
    return this._$parent._$isConnected;
  }
  constructor(e, t, n, s, r) {
    this.type = me, this._$committedValue = p, this._$disconnectableChildren = void 0, this.element = e, this.name = t, this._$parent = s, this.options = r, n.length > 2 || n[0] !== "" || n[1] !== "" ? (this._$committedValue = new Array(n.length - 1).fill(new String()), this.strings = n) : this._$committedValue = p, this._sanitizer = void 0;
  }
  /**
   * Sets the value of this part by resolving the value from possibly multiple
   * values and static strings and committing it to the DOM.
   * If this part is single-valued, `this._strings` will be undefined, and the
   * method will be called with a single value argument. If this part is
   * multi-value, `this._strings` will be defined, and the method is called
   * with the value array of the part's owning TemplateInstance, and an offset
   * into the value array from which the values should be read.
   * This method is overloaded this way to eliminate short-lived array slices
   * of the template instance values, and allow a fast-path for single-valued
   * parts.
   *
   * @param value The part value, or an array of values for multi-valued parts
   * @param valueIndex the index to start reading values from. `undefined` for
   *   single-valued parts
   * @param noCommit causes the part to not commit its value to the DOM. Used
   *   in hydration to prime attribute parts with their first-rendered value,
   *   but not set the attribute, and in SSR to no-op the DOM operation and
   *   capture the value for serialization.
   *
   * @internal
   */
  _$setValue(e, t = this, n, s) {
    const r = this.strings;
    let o = !1;
    if (r === void 0)
      e = v(this, e, t, 0), o = !O(e) || e !== this._$committedValue && e !== R, o && (this._$committedValue = e);
    else {
      const c = e;
      e = r[0];
      let a, l;
      for (a = 0; a < r.length - 1; a++)
        l = v(this, c[n + a], t, a), l === R && (l = this._$committedValue[a]), o || (o = !O(l) || l !== this._$committedValue[a]), l === p ? e = p : e !== p && (e += (l ?? "") + r[a + 1]), this._$committedValue[a] = l;
    }
    o && !s && this._commitValue(e);
  }
  /** @internal */
  _commitValue(e) {
    e === p ? b(this.element).removeAttribute(this.name) : (this._sanitizer === void 0 && (this._sanitizer = x(this.element, this.name, "attribute")), e = this._sanitizer(e ?? ""), d && d({
      kind: "commit attribute",
      element: this.element,
      name: this.name,
      value: e,
      options: this.options
    }), b(this.element).setAttribute(this.name, e ?? ""));
  }
}
class St extends K {
  constructor() {
    super(...arguments), this.type = ft;
  }
  /** @internal */
  _commitValue(e) {
    this._sanitizer === void 0 && (this._sanitizer = x(this.element, this.name, "property")), e = this._sanitizer(e), d && d({
      kind: "commit property",
      element: this.element,
      name: this.name,
      value: e,
      options: this.options
    }), this.element[this.name] = e === p ? void 0 : e;
  }
}
class Pt extends K {
  constructor() {
    super(...arguments), this.type = mt;
  }
  /** @internal */
  _commitValue(e) {
    d && d({
      kind: "commit boolean attribute",
      element: this.element,
      name: this.name,
      value: !!(e && e !== p),
      options: this.options
    }), b(this.element).toggleAttribute(this.name, !!e && e !== p);
  }
}
class Et extends K {
  constructor(e, t, n, s, r) {
    if (super(e, t, n, s, r), this.type = _t, this.strings !== void 0)
      throw new Error(`A \`<${e.localName}>\` has a \`@${t}=...\` listener with invalid content. Event listeners in templates must have exactly one expression and no surrounding text.`);
  }
  // EventPart does not use the base _$setValue/_resolveValue implementation
  // since the dirty checking is more complex
  /** @internal */
  _$setValue(e, t = this) {
    if (e = v(this, e, t, 0) ?? p, e === R)
      return;
    const n = this._$committedValue, s = e === p && n !== p || e.capture !== n.capture || e.once !== n.once || e.passive !== n.passive, r = e !== p && (n === p || s);
    d && d({
      kind: "commit event listener",
      element: this.element,
      name: this.name,
      value: e,
      options: this.options,
      removeListener: s,
      addListener: r,
      oldListener: n
    }), s && this.element.removeEventListener(this.name, this, n), r && this.element.addEventListener(this.name, this, e), this._$committedValue = e;
  }
  handleEvent(e) {
    var t;
    typeof this._$committedValue == "function" ? this._$committedValue.call(((t = this.options) == null ? void 0 : t.host) ?? this.element, e) : this._$committedValue.handleEvent(e);
  }
}
class Ct {
  constructor(e, t, n) {
    this.element = e, this.type = _e, this._$disconnectableChildren = void 0, this._$parent = t, this.options = n;
  }
  // See comment in Disconnectable interface for why this is a getter
  get _$isConnected() {
    return this._$parent._$isConnected;
  }
  _$setValue(e) {
    d && d({
      kind: "commit to element binding",
      element: this.element,
      value: e,
      options: this.options
    }), v(this, e);
  }
}
const se = _.litHtmlPolyfillSupportDevMode;
se == null || se(I, D);
(_.litHtmlVersions ?? (_.litHtmlVersions = [])).push("3.2.1");
_.litHtmlVersions.length > 1 && k("multiple-versions", "Multiple versions of Lit loaded. Loading multiple versions is not recommended.");
const J = (i, e, t) => {
  if (e == null)
    throw new TypeError(`The container to render into may not be ${e}`);
  const n = it++, s = (t == null ? void 0 : t.renderBefore) ?? e;
  let r = s._$litPart$;
  if (d && d({
    kind: "begin render",
    id: n,
    value: i,
    container: e,
    options: t,
    part: r
  }), r === void 0) {
    const o = (t == null ? void 0 : t.renderBefore) ?? null;
    s._$litPart$ = r = new D(e.insertBefore(V(), o), o, void 0, t ?? {});
  }
  return r._$setValue(i), d && d({
    kind: "end render",
    id: n,
    value: i,
    container: e,
    options: t,
    part: r
  }), r;
};
J.setSanitizer = st, J.createSanitizer = de, J._testOnlyClearSanitizerFactoryDoNotCallOrElse = rt;
/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
const Tt = (i, e) => i;
let He;
{
  const i = globalThis.litIssuedWarnings ?? (globalThis.litIssuedWarnings = /* @__PURE__ */ new Set());
  He = (e, t) => {
    t += ` See https://lit.dev/msg/${e} for more information.`, i.has(t) || (console.warn(t), i.add(t));
  };
}
class z extends P {
  constructor() {
    super(...arguments), this.renderOptions = { host: this }, this.__childPart = void 0;
  }
  /**
   * @category rendering
   */
  createRenderRoot() {
    var t;
    const e = super.createRenderRoot();
    return (t = this.renderOptions).renderBefore ?? (t.renderBefore = e.firstChild), e;
  }
  /**
   * Updates the element. This method reflects property values to attributes
   * and calls `render` to render DOM via lit-html. Setting properties inside
   * this method will *not* trigger another update.
   * @param changedProperties Map of changed properties with old values
   * @category updates
   */
  update(e) {
    const t = this.render();
    this.hasUpdated || (this.renderOptions.isConnected = this.isConnected), super.update(e), this.__childPart = J(t, this.renderRoot, this.renderOptions);
  }
  /**
   * Invoked when the component is added to the document's DOM.
   *
   * In `connectedCallback()` you should setup tasks that should only occur when
   * the element is connected to the document. The most common of these is
   * adding event listeners to nodes external to the element, like a keydown
   * event handler added to the window.
   *
   * ```ts
   * connectedCallback() {
   *   super.connectedCallback();
   *   addEventListener('keydown', this._handleKeydown);
   * }
   * ```
   *
   * Typically, anything done in `connectedCallback()` should be undone when the
   * element is disconnected, in `disconnectedCallback()`.
   *
   * @category lifecycle
   */
  connectedCallback() {
    var e;
    super.connectedCallback(), (e = this.__childPart) == null || e.setConnected(!0);
  }
  /**
   * Invoked when the component is removed from the document's DOM.
   *
   * This callback is the main signal to the element that it may no longer be
   * used. `disconnectedCallback()` should ensure that nothing is holding a
   * reference to the element (such as event listeners added to nodes external
   * to the element), so that it is free to be garbage collected.
   *
   * ```ts
   * disconnectedCallback() {
   *   super.disconnectedCallback();
   *   window.removeEventListener('keydown', this._handleKeydown);
   * }
   * ```
   *
   * An element may be re-connected after being disconnected.
   *
   * @category lifecycle
   */
  disconnectedCallback() {
    var e;
    super.disconnectedCallback(), (e = this.__childPart) == null || e.setConnected(!1);
  }
  /**
   * Invoked on each update to perform rendering tasks. This method may return
   * any value renderable by lit-html's `ChildPart` - typically a
   * `TemplateResult`. Setting properties inside this method will *not* trigger
   * the element to update.
   * @category rendering
   */
  render() {
    return R;
  }
}
z._$litElement$ = !0;
z[Tt("finalized")] = !0;
var ke;
(ke = globalThis.litElementHydrateSupport) == null || ke.call(globalThis, { LitElement: z });
const re = globalThis.litElementPolyfillSupportDevMode;
re == null || re({ LitElement: z });
(globalThis.litElementVersions ?? (globalThis.litElementVersions = [])).push("4.1.1");
globalThis.litElementVersions.length > 1 && He("multiple-versions", "Multiple versions of Lit loaded. Loading multiple versions is not recommended.");
/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
const xt = (i) => (e, t) => {
  t !== void 0 ? t.addInitializer(() => {
    customElements.define(i, e);
  }) : customElements.define(i, e);
};
/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
let Fe;
{
  const i = globalThis.litIssuedWarnings ?? (globalThis.litIssuedWarnings = /* @__PURE__ */ new Set());
  Fe = (e, t) => {
    t += ` See https://lit.dev/msg/${e} for more information.`, i.has(t) || (console.warn(t), i.add(t));
  };
}
const Nt = (i, e, t) => {
  const n = e.hasOwnProperty(t);
  return e.constructor.createProperty(t, n ? { ...i, wrapped: !0 } : i), n ? Object.getOwnPropertyDescriptor(e, t) : void 0;
}, Rt = {
  attribute: !0,
  type: String,
  converter: Y,
  reflect: !1,
  hasChanged: ue
}, vt = (i = Rt, e, t) => {
  const { kind: n, metadata: s } = t;
  s == null && Fe("missing-class-metadata", `The class ${e} is missing decorator metadata. This could mean that you're using a compiler that supports decorators but doesn't support decorator metadata, such as TypeScript 5.1. Please update your compiler.`);
  let r = globalThis.litPropertyMetadata.get(s);
  if (r === void 0 && globalThis.litPropertyMetadata.set(s, r = /* @__PURE__ */ new Map()), r.set(t.name, i), n === "accessor") {
    const { name: o } = t;
    return {
      set(c) {
        const a = e.get.call(this);
        e.set.call(this, c), this.requestUpdate(o, a, i);
      },
      init(c) {
        return c !== void 0 && this._$changeProperty(o, void 0, i), c;
      }
    };
  } else if (n === "setter") {
    const { name: o } = t;
    return function(c) {
      const a = this[o];
      e.call(this, c), this.requestUpdate(o, a, i);
    };
  }
  throw new Error(`Unsupported decorator location: ${n}`);
};
function L(i) {
  return (e, t) => typeof t == "object" ? vt(i, e, t) : Nt(i, e, t);
}
/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
globalThis.litIssuedWarnings ?? (globalThis.litIssuedWarnings = /* @__PURE__ */ new Set());
/**
 * @license
 * Copyright 2020 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
var Ve, Oe;
(Ve = window.ShadyDOM) != null && Ve.inUse && ((Oe = window.ShadyDOM) == null ? void 0 : Oe.noPatch) === !0 && window.ShadyDOM.wrap;
const At = (i) => i.strings === void 0;
/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
const Ut = {
  ATTRIBUTE: 1,
  CHILD: 2,
  PROPERTY: 3,
  BOOLEAN_ATTRIBUTE: 4,
  EVENT: 5,
  ELEMENT: 6
}, Mt = (i) => (...e) => ({
  // This property needs to remain unminified.
  _$litDirective$: i,
  values: e
});
class kt {
  constructor(e) {
  }
  // See comment in Disconnectable interface for why this is a getter
  get _$isConnected() {
    return this._$parent._$isConnected;
  }
  /** @internal */
  _$initialize(e, t, n) {
    this.__part = e, this._$parent = t, this.__attributeIndex = n;
  }
  /** @internal */
  _$resolve(e, t) {
    return this.update(e, t);
  }
  update(e, t) {
    return this.render(...t);
  }
}
/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
const M = (i, e) => {
  var n;
  const t = i._$disconnectableChildren;
  if (t === void 0)
    return !1;
  for (const s of t)
    (n = s._$notifyDirectiveConnectionChanged) == null || n.call(s, e, !1), M(s, e);
  return !0;
}, Z = (i) => {
  let e, t;
  do {
    if ((e = i._$parent) === void 0)
      break;
    t = e._$disconnectableChildren, t.delete(i), i = e;
  } while ((t == null ? void 0 : t.size) === 0);
}, Be = (i) => {
  for (let e; e = i._$parent; i = e) {
    let t = e._$disconnectableChildren;
    if (t === void 0)
      e._$disconnectableChildren = t = /* @__PURE__ */ new Set();
    else if (t.has(i))
      break;
    t.add(i), It(e);
  }
};
function Vt(i) {
  this._$disconnectableChildren !== void 0 ? (Z(this), this._$parent = i, Be(this)) : this._$parent = i;
}
function Ot(i, e = !1, t = 0) {
  const n = this._$committedValue, s = this._$disconnectableChildren;
  if (!(s === void 0 || s.size === 0))
    if (e)
      if (Array.isArray(n))
        for (let r = t; r < n.length; r++)
          M(n[r], !1), Z(n[r]);
      else n != null && (M(n, !1), Z(n));
    else
      M(this, i);
}
const It = (i) => {
  i.type == Ut.CHILD && (i._$notifyConnectionChanged ?? (i._$notifyConnectionChanged = Ot), i._$reparentDisconnectables ?? (i._$reparentDisconnectables = Vt));
};
class Dt extends kt {
  constructor() {
    super(...arguments), this._$disconnectableChildren = void 0;
  }
  /**
   * Initialize the part with internal fields
   * @param part
   * @param parent
   * @param attributeIndex
   */
  _$initialize(e, t, n) {
    super._$initialize(e, t, n), Be(this), this.isConnected = e._$isConnected;
  }
  // This property needs to remain unminified.
  /**
   * Called from the core code when a directive is going away from a part (in
   * which case `shouldRemoveFromParent` should be true), and from the
   * `setChildrenConnected` helper function when recursively changing the
   * connection state of a tree (in which case `shouldRemoveFromParent` should
   * be false).
   *
   * @param isConnected
   * @param isClearingDirective - True when the directive itself is being
   *     removed; false when the tree is being disconnected
   * @internal
   */
  _$notifyDirectiveConnectionChanged(e, t = !0) {
    var n, s;
    e !== this.isConnected && (this.isConnected = e, e ? (n = this.reconnected) == null || n.call(this) : (s = this.disconnected) == null || s.call(this)), t && (M(this, e), Z(this));
  }
  /**
   * Sets the value of the directive's Part outside the normal `update`/`render`
   * lifecycle of a directive.
   *
   * This method should not be called synchronously from a directive's `update`
   * or `render`.
   *
   * @param directive The directive to update
   * @param value The value to set
   */
  setValue(e) {
    if (At(this.__part))
      this.__part._$setValue(e, this);
    else {
      if (this.__attributeIndex === void 0)
        throw new Error("Expected this.__attributeIndex to be a number");
      const t = [...this.__part._$committedValue];
      t[this.__attributeIndex] = e, this.__part._$setValue(t, this, 0);
    }
  }
  /**
   * User callbacks for implementing logic to release any resources/subscriptions
   * that may have been retained by this directive. Since directives may also be
   * re-connected, `reconnected` should also be implemented to restore the
   * working state of the directive prior to the next render.
   */
  disconnected() {
  }
  reconnected() {
  }
}
/**
 * @license
 * Copyright 2020 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
const oe = /* @__PURE__ */ new WeakMap();
class zt extends Dt {
  render(e) {
    return p;
  }
  update(e, [t]) {
    var s;
    const n = t !== this._ref;
    return n && this._ref !== void 0 && this._updateRefValue(void 0), (n || this._lastElementForRef !== this._element) && (this._ref = t, this._context = (s = e.options) == null ? void 0 : s.host, this._updateRefValue(this._element = e.element)), p;
  }
  _updateRefValue(e) {
    if (this.isConnected || (e = void 0), typeof this._ref == "function") {
      const t = this._context ?? globalThis;
      let n = oe.get(t);
      n === void 0 && (n = /* @__PURE__ */ new WeakMap(), oe.set(t, n)), n.get(this._ref) !== void 0 && this._ref.call(this._context, void 0), n.set(this._ref, e), e !== void 0 && this._ref.call(this._context, e);
    } else
      this._ref.value = e;
  }
  get _lastElementForRef() {
    var e, t;
    return typeof this._ref == "function" ? (e = oe.get(this._context ?? globalThis)) == null ? void 0 : e.get(this._ref) : (t = this._ref) == null ? void 0 : t.value;
  }
  disconnected() {
    this._lastElementForRef === this._element && this._updateRefValue(void 0);
  }
  reconnected() {
    this._updateRefValue(this._element);
  }
}
const Lt = Mt(zt);
var f = [];
for (var ae = 0; ae < 256; ++ae)
  f.push((ae + 256).toString(16).slice(1));
function Wt(i, e = 0) {
  return (f[i[e + 0]] + f[i[e + 1]] + f[i[e + 2]] + f[i[e + 3]] + "-" + f[i[e + 4]] + f[i[e + 5]] + "-" + f[i[e + 6]] + f[i[e + 7]] + "-" + f[i[e + 8]] + f[i[e + 9]] + "-" + f[i[e + 10]] + f[i[e + 11]] + f[i[e + 12]] + f[i[e + 13]] + f[i[e + 14]] + f[i[e + 15]]).toLowerCase();
}
var F, Ht = new Uint8Array(16);
function Ft() {
  if (!F && (F = typeof crypto < "u" && crypto.getRandomValues && crypto.getRandomValues.bind(crypto), !F))
    throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");
  return F(Ht);
}
var Bt = typeof crypto < "u" && crypto.randomUUID && crypto.randomUUID.bind(crypto);
const ve = {
  randomUUID: Bt
};
function qt(i, e, t) {
  if (ve.randomUUID && !e && !i)
    return ve.randomUUID();
  i = i || {};
  var n = i.random || (i.rng || Ft)();
  return n[6] = n[6] & 15 | 64, n[8] = n[8] & 63 | 128, Wt(n);
}
const Jt = "@engineai-dev/web-component", Yt = "1.1.0";
class Gt extends Event {
  constructor(e) {
    super("state-change"), this.action = e;
  }
}
class Qt {
  constructor(e) {
    this.element = e, this.abortController = new AbortController(), this.target = null, window.addEventListener(
      "message",
      (t) => {
        if (t.data.instance !== this.element.instanceId)
          return;
        const n = t.data.action;
        this.element.dispatchEvent(
          new Gt(n)
        );
      },
      {
        signal: this.abortController.signal
      }
    );
  }
  /**
   * client to dispatch actions on the remote endpoint
   */
  dispatch(e, t) {
    if (!this.target)
      throw new Error("call connect() before using remote");
    this.target.postMessage(
      {
        instance: this.element.instanceId,
        source: Jt,
        action: {
          type: e,
          data: t
        }
      },
      "*"
    );
  }
  connect(e) {
    this.target = e;
  }
  disconnect() {
    this.target = null;
  }
  destroy() {
    this.abortController.abort();
  }
}
function Zt(i, e) {
  if (!i)
    return null;
  const t = window[i];
  return t ? (n) => {
    t(n);
  } : new Function("", i);
}
var jt = Object.defineProperty, Kt = Object.getOwnPropertyDescriptor, A = (i, e, t, n) => {
  for (var s = n > 1 ? void 0 : n ? Kt(e, t) : e, r = i.length - 1, o; r >= 0; r--)
    (o = i[r]) && (s = (n ? o(e, t, s) : o(s)) || s);
  return n && s && jt(e, t, s), s;
};
const qe = "engineai-web-component";
let w = class extends z {
  constructor() {
    super(), this.src = "", this.options = void 0, this.token = void 0, this.resizable = !0, this.onStateChange = null, this.instanceId = qt(), this.remoteManager = new Qt(this), this.isLoaded = !1, this.contentHeightChangeHandler = (i) => {
      var e;
      !this.resizable || i.action.type !== "content-height-change" || (this.style.minHeight = ((e = i.action.data) == null ? void 0 : e.height) != null ? `${i.action.data.height}px` : "");
    }, this.addEventListener("state-change", (i) => {
      var e;
      return (e = this.onStateChange) == null ? void 0 : e.call(this, i);
    }), this.addEventListener("state-change", this.contentHeightChangeHandler);
  }
  /**
   * @param property - camel case property
   * @returns attribute name using kebab case (hyphen)
   */
  static attributeNameForProperty(i) {
    return i.replace(/[A-Z]/g, (e) => `-${e.toLowerCase()}`);
  }
  updated(i) {
    this.isLoaded && (i.has("src") && this.onSrcUpdate(i.get("src")), i.has("token") && this.onTokenUpdate(i.get("token")), i.has("options") && this.onOptionsUpdate());
  }
  onSrcUpdate(i) {
    if (this.src) {
      const e = new URL(this.src), t = new URL(i);
      e.origin === t.origin ? this.remoteManager.dispatch("location-change", {
        path: e.pathname + e.search + e.hash
      }) : this.iframe.src = this.src;
    }
  }
  onTokenUpdate(i) {
    this.token ? this.remoteManager.dispatch("login", { token: this.token }) : i && this.remoteManager.dispatch("logout");
  }
  onOptionsUpdate() {
    this.options && this.remoteManager.dispatch("options", this.options);
  }
  disconnectedCallback() {
    super.disconnectedCallback(), this.remoteManager.destroy();
  }
  render() {
    return this.src ? bt`
      <iframe
        ${Lt(this.iframeRefCallback)}
        title="EngineAI Web Component"
        frameborder="0"
      ></iframe>
    ` : null;
  }
  /**
   * ref callback called with element on mount or null on unmount
   */
  iframeRefCallback(i) {
    if (this.iframe = i, !i) {
      this.remoteManager.disconnect(), this.isLoaded = !1;
      return;
    }
    const e = new URL(this.src), t = new URLSearchParams(e.search);
    t.set("web-component-version", Yt), t.set("web-component-instance", this.instanceId), t.set("web-component-resizable", this.resizable.toString()), e.search = t.toString(), i.src = e.href, i.onload = () => {
      this.remoteManager.connect(i.contentWindow), this.isLoaded = !0;
      const n = Object.entries({
        token: void 0,
        options: void 0
      });
      this.updated(new Map(n));
    };
  }
  addEventListener(i, e, t) {
    super.addEventListener(
      i,
      e,
      t
    );
  }
  removeEventListener(i, e, t) {
    super.removeEventListener(
      i,
      e,
      t
    );
  }
  dispatchEvent(i) {
    return super.dispatchEvent(i);
  }
};
w.tagName = qe;
w.shadowRootOptions = {
  mode: "open"
};
w.styles = Ge`
    iframe {
      height: 100%;
      width: 100%;
    }
  `;
A([
  L({ type: String, reflect: !0 })
], w.prototype, "src", 2);
A([
  L({ type: String, reflect: !0 })
], w.prototype, "options", 2);
A([
  L({ type: String, reflect: !0 })
], w.prototype, "token", 2);
A([
  L({ type: Boolean, reflect: !0 })
], w.prototype, "resizable", 2);
A([
  L({
    converter: Zt,
    reflect: !1
  })
], w.prototype, "onStateChange", 2);
w = A([
  xt(qe)
], w);
export {
  w as EngineAIWebComponentElement,
  Gt as EngineAIWebComponentStateChangeEvent
};
