import { LitElement } from 'lit';
import { EngineAIWebComponentEventHandlers, EngineAIWebComponentEventMap } from './events';

declare const TAG_NAME = "engineai-web-component";
declare global {
    interface HTMLElementTagNameMap {
        [TAG_NAME]: EngineAIWebComponentElement;
    }
}
export interface EngineAIWebComponentAttributes {
    src: string;
    token?: string;
    resizable?: boolean;
    options?: Record<string, unknown>;
}
export declare class EngineAIWebComponentElement extends LitElement implements EngineAIWebComponentAttributes, EngineAIWebComponentEventHandlers {
    static readonly tagName = "engineai-web-component";
    static readonly shadowRootOptions: ShadowRootInit;
    static readonly styles: import('lit').CSSResult;
    /**
     * @param property - camel case property
     * @returns attribute name using kebab case (hyphen)
     */
    static attributeNameForProperty(property: string): string;
    src: string;
    options: EngineAIWebComponentAttributes['options'];
    token: EngineAIWebComponentAttributes['token'];
    readonly resizable: boolean;
    onStateChange: EngineAIWebComponentEventHandlers['onStateChange'];
    readonly instanceId: string;
    private remoteManager;
    private isLoaded;
    private iframe?;
    constructor();
    private contentHeightChangeHandler;
    updated(changedProperties: Map<keyof EngineAIWebComponentAttributes, unknown>): void;
    private onSrcUpdate;
    private onTokenUpdate;
    private onOptionsUpdate;
    disconnectedCallback(): void;
    render(): import('lit').TemplateResult<1> | null;
    /**
     * ref callback called with element on mount or null on unmount
     */
    private iframeRefCallback;
    addEventListener<K extends keyof EngineAIWebComponentEventMap>(type: K, listener: (this: EngineAIWebComponentElement, ev: EngineAIWebComponentEventMap[K]) => void, options?: boolean | AddEventListenerOptions | undefined): void;
    removeEventListener<K extends keyof EngineAIWebComponentEventMap>(type: K, listener: (this: EngineAIWebComponentElement, ev: EngineAIWebComponentEventMap[K]) => void, options?: boolean | EventListenerOptions | undefined): void;
    dispatchEvent<K extends keyof EngineAIWebComponentEventMap>(ev: EngineAIWebComponentEventMap[K]): boolean;
}
export {};
