import { EngineAIWebComponentElement } from './component';

export interface EngineAIWebComponentEventMap {
    'state-change': EngineAIWebComponentStateChangeEvent;
    [key: string]: Event;
}
export type OptionsEventAction = {
    type: 'options';
    data: Record<string, unknown>;
};
export type LocationChangeEventAction = {
    type: 'location-change';
    data: {
        path: string;
    };
};
export type LoginEventAction = {
    type: 'login';
    data: {
        token: string;
    };
};
export type LogoutEventAction = {
    type: 'logout';
    data?: never;
};
export type WebComponentEventAction = OptionsEventAction | LocationChangeEventAction | LoginEventAction | LogoutEventAction;
export type ContentHeightChangeEventAction = {
    type: 'content-height-change';
    data: {
        height: number;
    };
};
export type RemoteStateEventAction = ContentHeightChangeEventAction | LocationChangeEventAction | {
    type: string;
    data?: Record<string, unknown>;
};
export declare class EngineAIWebComponentStateChangeEvent extends Event {
    readonly action: RemoteStateEventAction;
    constructor(action: RemoteStateEventAction);
}
export interface EngineAIWebComponentEventHandlers {
    onStateChange: ((this: EngineAIWebComponentElement, ev: EngineAIWebComponentStateChangeEvent) => void) | null;
}
