import { EngineAIWebComponentElement } from './component';
import { WebComponentEventAction } from './events';

/**
 * manages the communication channel
 */
export declare class RemoteManager {
    private element;
    private abortController;
    private target;
    constructor(element: EngineAIWebComponentElement);
    /**
     * client to dispatch actions on the remote endpoint
     */
    dispatch<T extends WebComponentEventAction['type']>(type: T, data?: Extract<WebComponentEventAction, {
        type: T;
    }>['data']): void;
    connect(target: Window): void;
    disconnect(): void;
    destroy(): void;
}
